--- res_agi.c.orig	2004-09-18 18:47:39.000000000 -0700
+++ res_agi.c	2004-09-18 15:47:20.000000000 -0700
@@ -892,6 +892,44 @@
 	return RESULT_SUCCESS;
 }
 
+static int handle_callcli(struct ast_channel *chan, AGI *agi, int argc, char *argv[])
+{
+  /* mike nugent - Sat Sep 18 15:18:18 PDT 2004 - mike@illuminatus.org */
+  int p[2];
+  int index, n, total;
+  char buf[129];   // /usr/include/linux/limits.h:#define PIPE_BUF 4096
+                   // # bytes in atomic write to a pipe
+  char *str = NULL;
+
+  if ( (pipe(p)) == -1 ) {
+    return RESULT_FAILURE;
+  }
+
+  ast_cli_command(p[1], argv[1]);
+
+  str=(char *)malloc(129);
+  memset(str,0,129);
+  memset(buf,0,129);
+  index = 1;
+  total = 0;
+  do {
+    n = read(p[0], buf, 128);
+    total += n;
+    buf[n] = '\0';
+    strcat(str,buf);
+    index++;
+    str = (char *)realloc(str,(index*128)+1);
+  } while ( n == 128 );
+
+  write(agi->fd, str, total);
+  fdprintf(agi->fd, "200 result=0\n");
+  fdprintf(agi->fd, "\n"); // we may need to call this in a loop to get all
+                           // the lines so return a newline at the end
+
+  return RESULT_SUCCESS;
+}
+
+
 static char usage_setmusic[] =
 " Usage: SET MUSIC ON <on|off> <class>\n"
 "	Enables/Disables the music on hold generator.  If <class> is\n"
@@ -1086,6 +1124,10 @@
 " Usage: NOOP\n"
 "    Does nothing.\n";
 
+static char usage_callcli[] =
+" Usage: CALLCLI \"<command>\"\n"
+"    Calls the CLI with the command and returns the result\n";
+
 static agi_command commands[MAX_COMMANDS] = {
 	{ { "answer", NULL }, handle_answer, "Asserts answer", usage_answer },
 	{ { "wait", "for", "digit", NULL }, handle_waitfordigit, "Waits for a digit to be pressed", usage_waitfordigit },
@@ -1116,7 +1158,8 @@
 	{ { "database", "del", NULL }, handle_dbdel, "Removes database key/value", usage_dbdel },
 	{ { "database", "deltree", NULL }, handle_dbdeltree, "Removes database keytree/value", usage_dbdeltree },
 	{ { "noop", NULL }, handle_noop, "Does nothing", usage_noop },
-	{ { "set", "music", NULL }, handle_setmusic, "Enable/Disable Music on hold generator", usage_setmusic }
+	{ { "set", "music", NULL }, handle_setmusic, "Enable/Disable Music on hold generator", usage_setmusic },
+  { { "callcli", NULL }, handle_callcli, "Calls a command from the CLI and returns the response", usage_callcli }
 };
 
 static void join(char *s, size_t len, char *w[])
